<?php
function bbcode($texto) {
  $tags = array(
  		  //Bsicos
          '/(?<!\\\\)\[color(?::\w+)?=(.*?)\](.*?)\[\/color(?::\w+)?\]/si'   => "<span style=\"color:\\1\">\\2</span>",
          '/(?<!\\\\)\[size(?::\w+)?=(.*?)\](.*?)\[\/size(?::\w+)?\]/si'     => "<span style=\"font-size:\\1\">\\2</span>",
          '/(?<!\\\\)\[b(?::\w+)?\](.*?)\[\/b(?::\w+)?\]/si'                 => "<span style=\"font-weight:bold\">\\1</span>",
          '/(?<!\\\\)\[center(?::\w+)?\](.*?)\[\/center(?::\w+)?\]/si'       => "<div style=\"text-align:center\">\\1</div>",

		  //dl, dt, dd
		  '/(?<!\\\\)\[dl(?::\w+)?\](.*?)\[\/dl(?::\w+)?\]/si'       => "<dl class=\"dl\">\\1</dl>",
		  '/(?<!\\\\)\[dt(?::\w+)?\](.*?)\[\/dt(?::\w+)?\]/si'       => "<dt class=\"dt\">\\1</dt>",
		  '/(?<!\\\\)\[dt2(?::\w+)?\](.*?)\[\/dt2(?::\w+)?\]/si'       => "<dt class=\"dt2\">\\1</dt>",
		  '/(?<!\\\\)\[dd(?::\w+)?\](.*?)\[\/dd(?::\w+)?\]/si'       => "<dd class=\"dd\">\\1</dd>",
		  '/(?<!\\\\)\[dd2(?::\w+)?\](.*?)\[\/dd2(?::\w+)?\]/si'       => "<dd class=\"dd2\">\\1</dd>",
		  
          // [code]
          '/(?<!\\\\)\[code(?::\w+)?\](.*?)\[\/code(?::\w+)?\]/si'           => "<div class=\"bb-code\">\\1</div>",

          // [url]
          '/(?<!\\\\)\[url(?::\w+)?\]www\.(.*?)\[\/url(?::\w+)?\]/si'        => "<a href=\"http://www.\\1\" target=\"_blank\">\\1</a>",
          '/(?<!\\\\)\[url(?::\w+)?\](.*?)\[\/url(?::\w+)?\]/si'             => "<a href=\"\\1\" target=\"_blank\">\\1</a>",
          '/(?<!\\\\)\[url(?::\w+)?=(.*?)?\](.*?)\[\/url(?::\w+)?\]/si'      => "<a href=\"\\1\" target=\"_blank\">\\2</a>",
          
		  // Imagens 
          '/(?<!\\\\)\[img(?::\w+)?\](.*?)\[\/img(?::\w+)?\]/si'             => "<img src=\"\\1\" alt=\"\\1\" class=\"bb-image\" />",
		  '/(?<!\\\\)\[poster(?::\w+)?\](.*?)\[\/poster(?::\w+)?\]/si'             => "<img src=\"\\1\" width=\"240\" height=\"100%\" alt=\"\\1\" class=\"bb-image\" />",
		  '/(?<!\\\\)\[shot(?::\w+)?\](.*?)\[\/shot(?::\w+)?\]/si'             => "<img src=\"\\1\" width=\"200\" height=\"100\" alt=\"\\1\" class=\"bb-image\" />",
          
		  // [list]
          '/(?<!\\\\)(?:\s*<br\s*\/?>\s*)?\[\*(?::\w+)?\](.*?)(?=(?:\s*<br\s*\/?>\s*)?\[\*|(?:\s*<br\s*\/?>\s*)?\[\/?list)/si' => "\n<li>\\1</li>",
          '/(?<!\\\\)(?:\s*<br\s*\/?>\s*)?\[\/list(:(?!u|o)\w+)?\](?:<br\s*\/?>)?/si'    => "\n</ul>",
          '/(?<!\\\\)(?:\s*<br\s*\/?>\s*)?\[list(:(?!u|o)\w+)?\]\s*(?:<br\s*\/?>)?/si'   => "\n<ul class=\"listitem\">",

          // escaped tags like \[b], \[color], \[url], ...
          '/\\\\(\[\/?\w+(?::\w+)*\])/'                                      => "\\1"

  );
  $texto = preg_replace(array_keys($tags), array_values($tags), $texto);
  return $texto;
}?>