<?php
/**
 * @author 		ThiagoInfo
 * @copyright	(c) 2009 - 2010 ThiagoInfo - mti.ly.
 * @license		http://mti.ly
 * @link		http://mti.ly
 * @since		dezembro 2009
 **/

class Conexao extends Consulta {
    const SRV = SRV;
    const USR = USR;
    const PSW = PSW;
    const BD = BD;
    //----------------------------------------------
    // CONECTA NA BASE DE DADOS, EM CASO DE ERRO SAI
    //----------------------------------------------
    public function conectar(){
        $this->conexao = @mysqli_connect( self::SRV, self::USR, self::PSW, self::BD );
        if (!$this->conexao){
            exit($this->_excep('A Conexao falhou: '.mysqli_connect_error()));
        }
    }
    //-------------------------------------------------------------
    // FECHA A CONEXO COM A BASE DE DADOS, APS A QUERY
    //-------------------------------------------------------------
    public function fechar(){
        if ($this->conexao){
            return @mysqli_close($this->conexao);
        }
    }
    //------------------------------------------------------------
    // FUNO PARA EXECUTAR A QUERY NA BASE DE DADOS
    //------------------------------------------------------------
    public function query($sql){
        // CONECTA NA BASE
        $this->conectar(); 
        // EXECUTA A QUERY
        $this->sql = mysqli_query($this->conexao, $sql);
        // EXIBE MENSAGEM EM CASO DE ERRO
        if (!$this->sql){
            $this->_excep('Erro na consulta: '.@mysqli_error($this->conexao).' Numero: '.@mysqli_errno($this->conexao));
        }
        
        return $this->sql;
    }
    //-------------------------------------------
    // EXIBE AS MSG DE ERRO ATRAVES DA CLASSE EXPEPTION
    //-------------------------------------------
    public function _excep($msg=null) {
        try {
            throw new Exception($msg);
        } catch (Exception $e){
            var_dump($e->getMessage());
        }
    }
    public function eouwh($dados){
        $eou = array('/\be\b/', '/\bou\b/');
        $andor = array(' AND', ' OR ');
        
        return preg_replace($eou, $andor, $dados);        
    }
    // REGISTROS AFETADOS PELA QUERY
    public function reg_afetados(){
        return mysqli_affected_rows($this->conexao);
    }
    // TOTAL DE REGISTROS DO SELECT
    public function reg_total($sql=null){
        if (!$sql){
            $sql = $this->sql;
        }
        
        return mysqli_num_rows($sql);
    }
    // RETORNA ID INSERIDO DO AUTO_INCREMENT	
	public function id_inserido(){
	   return mysqli_insert_id($this->conexao);
    }
    // LIBERA MEMORIA
	public function libera_mem($sql=null){
	   if (!$sql){
	       $sql = $this->sql;
        }
        @mysqli_free_result($sql);
    }
    public function reg_assoc($sql=null){
        if (!$sql){
            $sql = $this->sql;
        }
        $this->reg_assoc = mysqli_fetch_assoc($sql);       

        return $this->reg_assoc;
    }
    public function reg_row($sql=null){
        if (!$sql){
            $sql = $this->sql;
        }
        $this->reg_assoc = mysqli_fetch_row($sql);       

        return $this->reg_assoc;
    }
    public function escape_str($texto){
        return mysqli_escape_string($this->conexao, $texto);
    }
} // end class
?>