<?php
abstract class Consulta {
    protected $sql = null;
    protected $conexao = null;
    protected $query_c = "";
    public $reg_assoc = array();
    
    // FECHA A CONEXO
    abstract public function fechar();
        
    public function consul($dados){
        $this->query_c = "SELECT ";
        if (isset($dados['sel']) && $dados['sel']){
            $virg = ",";
        }
        if (isset($dados['dist']) && $dados['dist']){
            $this->query_c .= "DISTINCT(".$dados['dist'].")".$virg;
        }
        if (isset($dados['sel']) && $dados['sel']){
            $this->query_c .= $dados['sel'];        }

        if (isset($dados['soma']) && $dados['soma'] && !$dados['sel']){
            $this->query_c .= "SUM(".$dados['soma'].") AS total";
        }
        if (isset($dados['pesq']) && $dados['pesq']){
            $this->query_c .= $virg."MATCH(".$dados['pesq'][0].") AGAINST('".$dados['pesq'][1]."' IN BOOLEAN MODE) AS ".$dados['pesq'][2]." ";
        }       
        if (isset($dados['fr']) && $dados['fr']){
            $this->query_c .= " FROM ";
            if (is_array($dados['fr'])){
                if(isset($dados['fr'][0]) && $dados['fr'][0]){
                    $from = $dados['fr'][0];
                } else {
                    $from = $dados['fr'];
                }
                $tabelas = array();
                foreach ($from AS $tabela => $alias){
                    if (!is_array($alias)){
                        $tabelas[] = " ".SQL_PREF.$tabela ." AS ".$alias;
                     }                   
                }
                if(isset($dados['jn']) && $dados['jn'] != ''){
                    $tipo = strtoupper($dados['jn']['tp']);
                    $this->query_c .= implode(" ".$tipo." JOIN ", $tabelas);                    
                    $this->query_c .= " ON ";
                    if(isset($dados['fr'][1]) && $dados['fr'][1]){
                        foreach ($dados['fr'][1] AS $tabela2 => $alias2){
                            $tabelas2 = " ".SQL_PREF.$tabela2 ." AS ".$alias2;
                        }
                        $tipo2 = strtoupper($dados['jn']['tp2']);
                        $jn2 = ' '.$tipo2.' JOIN '.$tabelas2;
                        $jn2 .= ' ON ';
                        
                    }  
                } else {
                    $this->query_c .= implode(',', $tabelas);                    
                }
                
            } else {
                $this->query_c .= SQL_PREF.$dados['fr'];
            }
        }
        // CONSULTA QUERY COM COM A CLAUSA WHERE
        if (isset($dados['wh']) && ($dados['wh'] != "")){
            if (!@$dados['jn']){
                $this->query_c .= " WHERE ";
            }
            if(is_array($dados['wh'])){
                $where = $dados['wh'][0];
                $where2 = $dados['wh'][1];
                $subs3 = $this->eouwh($where2);
                $jn2 = $jn2.' '.$subs3;
            } else {
                $where = $dados['wh'];
            }
            
            $subs = $this->eouwh($where);            
            $this->query_c .= $subs;
            $this->query_c .= @$jn2;
        }
                
        // CONSULTANDO COM MYSQL FULL TEXT MATCH
        if (isset($dados['pesq']) && $dados['pesq']){
            if($dados['wh']){
                $this->query_c .= " AND";
            } else {
                $this->query_c .= " WHERE";
            }
            $this->query_c .= " MATCH(".$dados['pesq'][0].") AGAINST('".$dados['pesq'][1]."' IN BOOLEAN MODE)"; 
        }
        // CONSULTA COM LIKE
        if (isset($dados['lk']) && $dados['lk']){
            $lk = array();
            foreach ($dados['lk'] AS $termo => $campo){
                $lk[] = "".$campo." LIKE '".$termo."'";
            }
            if ($dados['wh']){
                $this->query_c .= " AND";
            } else {
                $this->query_c .= " WHERE";
            }
            $this->query_c .= " (".implode(' OR ', $lk).")";
        }
        // CONSULTADO COM ORDER BY
        if (isset($dados['ord']) && $dados['ord'] != ""){
            $this->query_c .= " ORDER BY " . $dados['ord'];
        }
        // CONSULTANDO RESULTADOS AGRUPADO
        if (isset($dados['grp']) && $dados['grp'] != ""){
            $this->query_c .= " GROUP BY " . $dados['grp'];
        }
        // CONSULTANDO RESULTAMOS COM LIMIT
        if (isset($dados['lim']) && is_array($dados['lim'])){
    		$this->query_c .= " LIMIT " . $dados['lim'][0]  . "," . $dados['lim'][1];
    	}
        
        return $this->query($this->query_c);       

    }
    //--------------------------------------------------------------
    // FUNO RESPONSVEL / SUBSTITUA DO INSERT TO INSERIR DADOS
    //--------------------------------------------------------------    
    public function inserir($tabela='', $dados){
        if(isset($tabela) && ($tabela != '') && (is_array($dados))){
            foreach ($dados AS $campo => $valor){
                $campos  .= $campo.",";
                if (is_numeric($valor) && intval($valor) == $valor){
                    $valores .= $valor.",";
                } else {
                    $valores .= "'".$valor."',";
                }
            }
            $campos  = rtrim($campos, "," );
            $valores = rtrim($valores, ",");
            
            $this->query_c = "INSERT INTO ".SQL_PREF.$tabela." (".$campos.") VALUES (".$valores.")";
            
            return $this->query($this->query_c);

        }        
        return false;
    }
    //----------------------------------------------------------
    // FUNO ATUALIZAR OS DADOS DA TABELA
    //----------------------------------------------------------
    public function atualizar($tabela='', $dados, $where='', $aspas = null){
        if(isset($tabela) && ($tabela != '') && (is_array($dados))){
            foreach ($dados AS $campo => $valor){
                if ((is_numeric($valor) && intval($valor) == $valor) || ($aspas)){
                    $cv .= $campo."=".$valor.",";
                } else {
                    $cv .= $campo."='".$valor."',";
                }
            }            
            $cv  = rtrim($cv, ",");            
            $this->query_c = "UPDATE ".SQL_PREF.$tabela." SET ".$cv;
            // CONSULTA QUERY COM COM A CLAUSA WHERE
            if (isset($where) && ($where != "")){
                $subs = $subs = $this->eouwh($where);
                $this->query_c .= " WHERE ".$subs;
            }
                        
            return $this->query($this->query_c);
        }        
        return false;
    }
    //-------------------------------------------------------------
    // EXCLUIR DADO DA TABELA OU EM MTIPLAS
    //-------------------------------------------------------------
    public function excluir($tabelas, $where=''){
        if(isset($tabelas) && ($tabelas != '')){
            $this->query_c = "DELETE ";
            if(is_array($tabelas)){
                foreach ($tabelas AS $tabela){
                    $tabs .= SQL_PREF.$tabela.",";
                }
                $tab  = rtrim($tabs, "," );
                $this->query_c .= $tab." FROM ".$tab;
            } else {
                $this->query_c .= " FROM ".SQL_PREF.$tabelas;                
            }
        } 
        // CONSULTA QUERY COM COM A CLAUSA WHERE
        if (isset($where) && ($where != "")){
            $subs = $this->eouwh($where);
            $this->query_c .= " WHERE ".$subs;
        }
                      
        return $this->query($this->query_c);    
    }
    // FECHA A CONEXO        
    public function __destruct(){ $this->fechar(); }
    
}
?>